# Class GameMode

#### Implements

- GameModeConfig

- Defined in src/game-mode.ts:33

#####
Index

### Constructors

constructor

### Properties

battleConfig
challenges
hasNoShop
hasRandomBiomes
hasRandomBosses
hasShortBiomes
hasTrainers
isChallenge
isClassic
isDaily
isEndless
isSplicedOnly
modeId

### Methods

getClearScoreBonus
getEnemyModifierChance
getFixedBattle
getName
getOverrideSpecies
getStartingBiome
getStartingLevel
getStartingMoney
getWaveForDifficulty
isBoss
isEndlessBoss
isEndlessMajorBoss
isEndlessMinorBoss
isFixedBattle
isTrainerBoss
isWaveFinal
isWaveTrainer
getModeName

## Constructors

### constructor

- new GameMode(modeId, config, battleConfig?): GameMode

- #### Parameters

  - modeId: GameModes
  - config: GameModeConfig
  - `Optional` battleConfig: FixedBattleConfigs

  #### Returns GameMode

  - Defined in src/game-mode.ts:48

## Properties

### battleConfig

battleConfig: FixedBattleConfigs

- Defined in src/game-mode.ts:46

### challenges

challenges: Challenge []

- Defined in src/game-mode.ts:45

### hasNoShop

hasNoShop: boolean

Implementation of GameModeConfig.hasNoShop

- Defined in src/game-mode.ts:39

### hasRandomBiomes

hasRandomBiomes: boolean

Implementation of GameModeConfig.hasRandomBiomes

- Defined in src/game-mode.ts:41

### hasRandomBosses

hasRandomBosses: boolean

Implementation of GameModeConfig.hasRandomBosses

- Defined in src/game-mode.ts:42

### hasShortBiomes

hasShortBiomes: boolean

Implementation of GameModeConfig.hasShortBiomes

- Defined in src/game-mode.ts:40

### hasTrainers

hasTrainers: boolean

Implementation of GameModeConfig.hasTrainers

- Defined in src/game-mode.ts:38

### isChallenge

isChallenge: boolean

Implementation of GameModeConfig.isChallenge

- Defined in src/game-mode.ts:44

### isClassic

isClassic: boolean

Implementation of GameModeConfig.isClassic

- Defined in src/game-mode.ts:35

### isDaily

isDaily: boolean

Implementation of GameModeConfig.isDaily

- Defined in src/game-mode.ts:37

### isEndless

isEndless: boolean

Implementation of GameModeConfig.isEndless

- Defined in src/game-mode.ts:36

### isSplicedOnly

isSplicedOnly: boolean

Implementation of GameModeConfig.isSplicedOnly

- Defined in src/game-mode.ts:43

### modeId

modeId: GameModes

- Defined in src/game-mode.ts:34

## Methods

### getClearScoreBonus

- getClearScoreBonus(): number

- #### Returns number

  - Defined in src/game-mode.ts:248

### getEnemyModifierChance

- getEnemyModifierChance(isBoss): number

- #### Parameters

  - isBoss: boolean

  #### Returns number

  - Defined in src/game-mode.ts:258

### getFixedBattle

- getFixedBattle(waveIndex): FixedBattleConfig

- Returns the config for the fixed battle for a particular wave.

  #### Parameters

  - waveIndex: number

    The wave to check.

  #### Returns FixedBattleConfig

  The fixed battle for this wave.

  - Defined in src/game-mode.ts:238

### getName

- getName(): string

- #### Returns string

  - Defined in src/game-mode.ts:270

### getOverrideSpecies

- getOverrideSpecies(waveIndex): default

- #### Parameters

  - waveIndex: number

  #### Returns default

  - Defined in src/game-mode.ts:155

### getStartingBiome

- getStartingBiome(scene): Biome

- #### Parameters

  - scene: default

    current BattleScene

  #### Returns Biome

  either:

  - random biome for Daily mode
  - override from overrides.ts
  - Town
  - Defined in src/game-mode.ts:92

### getStartingLevel

- getStartingLevel(): number

- #### Returns number

  either:

  - override from overrides.ts
  - 20 for Daily Runs
  - 5 for all other modes
  - Defined in src/game-mode.ts:64

### getStartingMoney

- getStartingMoney(): number

- #### Returns number

  either:

  - override from overrides.ts
  - 1000
  - Defined in src/game-mode.ts:81

### getWaveForDifficulty

- getWaveForDifficulty(waveIndex, ignoreCurveChanges?): number

- #### Parameters

  - waveIndex: number
  - ignoreCurveChanges: boolean = false

  #### Returns number

  - Defined in src/game-mode.ts:101

### isBoss

- isBoss(waveIndex): boolean

- Every 10 waves is a boss battle

  #### Parameters

  - waveIndex: number

  #### Returns boolean

  true if waveIndex is a multiple of 10

  - Defined in src/game-mode.ts:188

### isEndlessBoss

- isEndlessBoss(waveIndex): boolean

- Every 50 waves of an Endless mode is a boss At this time it is paradox pokemon

  #### Parameters

  - waveIndex: number

  #### Returns boolean

  true if waveIndex is a multiple of 50 in Endless

  - Defined in src/game-mode.ts:197

### isEndlessMajorBoss

- isEndlessMajorBoss(waveIndex): boolean

- Every 1000 waves of an Endless mode is a major boss At this time it is Eternamax Eternatus

  #### Parameters

  - waveIndex: number

  #### Returns boolean

  true if waveIndex is a multiple of 1000 in Endless

  - Defined in src/game-mode.ts:217

### isEndlessMinorBoss

- isEndlessMinorBoss(waveIndex): boolean

- Every 250 waves of an Endless mode is a minor boss At this time it is Eternatus

  #### Parameters

  - waveIndex: number

  #### Returns boolean

  true if waveIndex is a multiple of 250 in Endless

  - Defined in src/game-mode.ts:207

### isFixedBattle

- isFixedBattle(waveIndex): boolean

- Checks whether there is a fixed battle on this gamemode on a given wave.

  #### Parameters

  - waveIndex: number

    The wave to check.

  #### Returns boolean

  If this game mode has a fixed battle on this wave

  - Defined in src/game-mode.ts:227

### isTrainerBoss

- isTrainerBoss(waveIndex, biomeType, offsetGym): boolean

- #### Parameters

  - waveIndex: number
  - biomeType: Biome
  - offsetGym: boolean

  #### Returns boolean

  - Defined in src/game-mode.ts:146

### isWaveFinal

- isWaveFinal(waveIndex, modeId?): boolean

- Checks if wave provided is the final for current or specified game mode

  #### Parameters

  - waveIndex: number
  - modeId: GameModes = ...

    game mode

  #### Returns boolean

  if the current wave is final for classic or daily OR a minor boss in endless

  - Defined in src/game-mode.ts:171

### isWaveTrainer

- isWaveTrainer(waveIndex, arena): boolean

- #### Parameters

  - waveIndex: number
  - arena: Arena

  #### Returns boolean

  - Defined in src/game-mode.ts:110

### `Static` getModeName

- getModeName(modeId): string

- #### Parameters

  - modeId: GameModes

  #### Returns string

  - Defined in src/game-mode.ts:285